ruperts | 2968132 | 2017-12-12 14:32:28 -0800 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright 2017 The Bazel Authors. All rights reserved. |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | # |
| 17 | # Integration tests for the network-dependent aspects of the sandboxing |
| 18 | # spawn strategy. In particular, those tests that specify -N should be in |
| 19 | # this file, but general tests can be kept in the more general |
| 20 | # linux-sandbox_test.sh. |
| 21 | # |
| 22 | |
| 23 | set -euo pipefail |
| 24 | |
| 25 | # Load the test setup defined in the parent directory |
| 26 | CURRENT_DIR="$(cd "$(dirname "${BASH_SOURCE[0]}")" && pwd)" |
| 27 | source "${CURRENT_DIR}/../integration_test_setup.sh" \ |
| 28 | || { echo "integration_test_setup.sh not found!" >&2; exit 1; } |
| 29 | source "${CURRENT_DIR}/../sandboxing_test_utils.sh" \ |
| 30 | || { echo "sandboxing_test_utils.sh not found!" >&2; exit 1; } |
| 31 | |
| 32 | enable_errexit |
| 33 | |
| 34 | readonly OUT_DIR="${TEST_TMPDIR}/out" |
| 35 | readonly SANDBOX_DIR="${OUT_DIR}/sandbox" |
| 36 | |
| 37 | SANDBOX_DEFAULT_OPTS="-W $SANDBOX_DIR" |
| 38 | |
| 39 | function set_up { |
| 40 | rm -rf $OUT_DIR |
| 41 | mkdir -p $SANDBOX_DIR |
| 42 | } |
| 43 | |
| 44 | function test_network_namespace() { |
philwo | 132a2c6 | 2019-06-24 04:58:44 -0700 | [diff] [blame] | 45 | $linux_sandbox $SANDBOX_DEFAULT_OPTS -N -- ip link ls &> $TEST_log || fail |
ruperts | 2968132 | 2017-12-12 14:32:28 -0800 | [diff] [blame] | 46 | expect_log "LOOPBACK,UP" |
| 47 | } |
| 48 | |
| 49 | function test_ping_loopback() { |
| 50 | $linux_sandbox $SANDBOX_DEFAULT_OPTS -N -R -- \ |
| 51 | /bin/sh -c 'ping6 -c 1 ::1 || ping -c 1 127.0.0.1' &>$TEST_log || fail |
| 52 | expect_log "1 received" |
| 53 | } |
| 54 | |
| 55 | # The test shouldn't fail if the environment doesn't support running it. |
jmmv | d411e8f | 2019-11-04 14:57:43 -0800 | [diff] [blame] | 56 | [[ "$(uname -s)" = Linux ]] || exit 0 |
ruperts | 2968132 | 2017-12-12 14:32:28 -0800 | [diff] [blame] | 57 | check_sandbox_allowed || exit 0 |
| 58 | |
| 59 | run_suite "linux-sandbox-network" |